#include "../include/Sniffer.h"
#include <iostream>

Sniffer::Sniffer(std::string interfaceName) : sniffer(interfaceName) {
    Tins::SnifferConfiguration config;
    config.set_promisc_mode(true);

    sniffer = Tins::Sniffer(interfaceName, config);
}

Sniffer::~Sniffer() {
}

void Sniffer::startSniffing() {
    sniffer.sniff_loop(make_sniffer_handler(this, &Sniffer::handle));
}

void Sniffer::setFilter(std::string filterString) {
    sniffer.set_filter(filterString);
}

bool Sniffer::handle(Tins::PDU& pdu) {
    // TODO implement handler for sniffed traffic

    std::cout << "packet sniffed" << std::endl;

    return false; // will stop sniffing after the first packet because this handler returns false
}
